package org.stm.wb.config.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.stm.wb.config.entity.WbCheckCfg;
import org.stm.wb.config.entity.WbCheckCfgParam;
import org.stm.wb.config.service.IWbCheckCfgService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @Description: 监测配置
 * @Author: jeecg-boot
 * @Date:   2025-06-19
 * @Version: V1.0
 */
@Api(tags="监测配置")
@RestController
@RequestMapping("/wb/config/wbCheckCfg")
@Slf4j
public class WbCheckCfgController extends JeecgController<WbCheckCfg, IWbCheckCfgService> {
	@Autowired
	private IWbCheckCfgService wbCheckCfgService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbCheckCfg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "监测配置-分页列表查询")
	@ApiOperation(value="监测配置-分页列表查询", notes="监测配置-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<WbCheckCfg>> queryPageList(WbCheckCfg wbCheckCfg,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbCheckCfg> queryWrapper = QueryGenerator.initQueryWrapper(wbCheckCfg, req.getParameterMap());
		Page<WbCheckCfg> page = new Page<WbCheckCfg>(pageNo, pageSize);
		IPage<WbCheckCfg> pageList = wbCheckCfgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	@GetMapping(value = "/listAll")
	public Result<List<WbCheckCfg>> listAll(WbCheckCfg wbCheckCfg,HttpServletRequest req) {
		QueryWrapper<WbCheckCfg> queryWrapper = QueryGenerator.initQueryWrapper(wbCheckCfg, req.getParameterMap());
		List<WbCheckCfg> list = wbCheckCfgService.list(queryWrapper);
		return Result.OK(list);
	}
	
	/**
	 *   添加
	 *
	 * @param
	 * @return
	 */
	@AutoLog(value = "监测配置-添加")
	@ApiOperation(value="监测配置-添加", notes="监测配置-添加")
	@RequiresPermissions("wb/config:wb_check_cfg:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbCheckCfgParam wbCheckCfgParam) {
		List<Integer> tidList = wbCheckCfgParam.getTids();
		if(tidList==null&&tidList.isEmpty()) {
			return Result.OK("缺少数据，保存失败！");
		}
		Integer stp = wbCheckCfgParam.getWbServiceTp();
		Integer wbLevel = wbCheckCfgParam.getWbLevel();
		Integer workplaceTp = wbCheckCfgParam.getWbWorkplaceTp();
		List<WbCheckCfg> dataList = new ArrayList<WbCheckCfg>();
		for(Integer id:tidList) {
			if(wbLevel!=null) {
				WbCheckCfg wbCheckCfg= new WbCheckCfg();
				wbCheckCfg.setTid(id);
				wbCheckCfg.setWbLevel(wbLevel);
				wbCheckCfg.setWbServiceTp(stp);
				wbCheckCfg.setWbWorkplaceTp(workplaceTp);
				wbCheckCfg.setDes(wbCheckCfgParam.getDes());
				dataList.add(wbCheckCfg);
			}
		}

		wbCheckCfgService.saveBatch(dataList);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbCheckCfg
	 * @return
	 */
	@AutoLog(value = "监测配置-编辑")
	@ApiOperation(value="监测配置-编辑", notes="监测配置-编辑")
	@RequiresPermissions("wb/config:wb_check_cfg:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbCheckCfg wbCheckCfg) {
		wbCheckCfgService.updateById(wbCheckCfg);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "监测配置-通过id删除")
	@ApiOperation(value="监测配置-通过id删除", notes="监测配置-通过id删除")
	@RequiresPermissions("wb/config:wb_check_cfg:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbCheckCfgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "监测配置-批量删除")
	@ApiOperation(value="监测配置-批量删除", notes="监测配置-批量删除")
	@RequiresPermissions("wb/config:wb_check_cfg:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbCheckCfgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "监测配置-通过id查询")
	@ApiOperation(value="监测配置-通过id查询", notes="监测配置-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<WbCheckCfg> queryById(@RequestParam(name="id",required=true) String id) {
		WbCheckCfg wbCheckCfg = wbCheckCfgService.getById(id);
		if(wbCheckCfg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbCheckCfg);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbCheckCfg
    */
    @RequiresPermissions("wb/config:wb_check_cfg:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbCheckCfg wbCheckCfg) {
        return super.exportXls(request, wbCheckCfg, WbCheckCfg.class, "监测配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb/config:wb_check_cfg:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbCheckCfg.class);
    }

}
